

%% Brinch Hansen profile 
function [KD_q,KD_c] = BH_Function(D,y,phi) 
    K0_q = exp((0.5.*pi + phi/180.*pi).*tan(phi/180.*pi)).*cos(phi/180.*pi).*tan((45+0.5.*phi)/180.*pi)...
        - exp(-(0.5.*pi-phi/180.*pi).*tan(phi/180.*pi)).*cos(phi/180.*pi).*tan((45-0.5.*phi)/180.*pi);
    K0_c = (exp((0.5.*pi + phi/180.*pi).*tan(phi/180.*pi)).*cos(phi/180.*pi).*tan((45+0.5.*phi)/180.*pi)-1).*cot(phi/180.*pi);
    if K0_c < 0
        K0_c =  2.5708; 
    end 
    dinf_c = 1.58 + 4.09*tan(phi/180*pi).^4; 
    Nc = (exp(pi.*tan(phi/180.*pi)).*tan(45/180*pi+0.5*phi/180.*pi).^2-1).*cot(phi/180.*pi); 
    if Nc < 0
        Nc =  5.1416;
    end 
    K0 = 1-sin(phi./180*pi);
    Kp = (1+sin(phi./180*pi))./(1-sin(phi./180*pi));
    Kinf_c = Nc.*dinf_c;
    Kinf_q = Kinf_c.*K0.*tan(phi/180*pi);
    alpha_q = K0_q.*K0.*sin(phi./180*pi)./((Kinf_q-K0_q).*sin(45/180*pi+0.5*phi./180*pi)); 
    if any(isnan(alpha_q), 'all')
        alpha_q = 0; 
    end
    alpha_c = K0_c/(Kinf_c-K0_c)*2*sin(45/180*pi+0.5*phi./180*pi); 
    KD_q =  (K0_q+Kinf_q.*alpha_q.*y./D)./(1+alpha_q.*y./D);
    KD_c = (K0_c + Kinf_c.* alpha_c*y./D)./(1+alpha_c*y./D); 
end 
