function [Brinch_Hansen] = BH_interpolation(pile_input,pile_output,Brinch_Hansen)
    [steps] = stepfunc(pile_input); 
    
    
    for pile = 1:size(pile_input,2)
        
        discrt_steps = steps(pile).discrete_steps;         
        x = round(pile_output(pile).grid.z',2); 
        
        for i = 1:size(discrt_steps,2)-1

            loc1 = find(abs(x-discrt_steps(i))<0.01);
            loc2 = find(abs(x-discrt_steps(i+1))<0.01)-1;

            y = Brinch_Hansen(pile).Force_correction;
            y_nc = Brinch_Hansen(pile).Force_no_correction; 
            x_interval = x(loc1:loc2) ;
            y_interval = y(loc1:loc2) ;

            if loc1 == loc2
                x_interval = [x(loc1), x(loc2+1)];
                y_interval = [y_interval,y_interval]; 
            end
            n_degree =2; 
            
            p =polyfit(x_interval,y_interval,n_degree); 

            syms y 
            BH_force = poly2sym(p,y); 
            [f] =  BH_force ;
            if f == 0 
                f = 0.001*y+ 0.001*y^2 + 0.001; 
            end 
            
            Brinch_Hansen(pile).functions(i,1) = f;
            
            Brinch_Hansen(pile).intervals(i,1) = loc1 ;
            Brinch_Hansen(pile).intervals(i,2) = loc2 ;
        end 
    end 

end 

