function  BH_plot(pile_input,pile_output,PLT)

rng('default');
lijn = 3; 
rng(21);
    %% Import parameters 
    n_piles = size(pile_input,2);
    top_piles = zeros(n_piles,1); 
    pile_length = zeros(n_piles,1); 
    plastic_zones = zeros(n_piles,1); 
    x_coordinates = zeros(n_piles,1); 
    for i = 1:n_piles 
        top_piles(i) = pile_input(i).top_pile;
        pile_length(i) = pile_input(i).pile_length; 
        plastic_zones(i) = pile_input(i).plastic_zone;
        x_coordinates(i) = pile_input(i).x_coordinate;
    end 
    top_first_pile = pile_input(1).top_pile; 
    helling = pile_input(1).helling;

if PLT.BHfactorplot == 1
    figure 
    %movegui('northeast');
    hold on 
    sgtitle('Brinch Hansen reduction factors for weight','Interpreter','latex'); 

    for pile = 1:n_piles 
            subplot(1,n_piles,pile)
            plot((pile_output(pile).BH_factors.weigthfactor),pile_output(pile).grid.z(2:end))
            hold on 
            plot((pile_output(pile).BH_factors.smoothweigthfactor),pile_output(pile).grid.z(2:end),'r--')
%             xlim([0,1]) 
            ylim([min(pile_output(pile).grid.z),max(pile_output(pile).grid.z)])
            title(['Pile ', num2str(pile)],'Interpreter','latex'); 
            xlabel('RF weight $[-]$','Interpreter','latex'); 
            ylabel('$z [m]$','Interpreter','latex'); 
            set(gca, 'YDir','reverse')
            grid on 

    end 

    figure 
    %movegui('southeast');
    sgtitle('Brinch Hansen reduction factors for cohesion','Interpreter','latex'); 
    for pile = 1:n_piles 
            subplot(1,n_piles,pile)
            plot((pile_output(pile).BH_factors.cohesionfactor),pile_output(pile).grid.z(2:end))
            hold on 
            plot((pile_output(pile).BH_factors.smoothcohesionfactor),pile_output(pile).grid.z(2:end),'r--')
%             xlim([0,1]) 
            ylim([min(pile_output(pile).grid.z),max(pile_output(pile).grid.z)])
            title(['Pile ', num2str(pile)],'Interpreter','latex'); 
            xlabel('RF cohesion $[-]$','Interpreter','latex'); 
            ylabel('$z [m]$','Interpreter','latex'); 
            set(gca, 'YDir','reverse')
            grid on 
    end 
end
end