function [BH_force]= BH_polyfunction(pile_input,pile_output,Brinch_Hansen,PLT)
if PLT.BH_forceplot == 1 
    figure 
    n_piles = size(pile_input,2);
    for pile = 1:n_piles
        
        y = Brinch_Hansen(pile).Force_correction; 
        y_nc = Brinch_Hansen(pile).Force_no_correction; 
        x = pile_output(pile).grid.z';
        hold on   
        subplot(1,4,pile)
        for i = 1:size(Brinch_Hansen(pile).intervals,1)
            f =Brinch_Hansen(pile).functions(i,1);
            loc1 = Brinch_Hansen(pile).intervals(i,1) ;
            loc2 = Brinch_Hansen(pile).intervals(i,2) ;
            p1 = fplot(f,[x(loc1) x(loc2+1)],'k');
            hold on 
        end 
            
        hold on 
        p2 = plot(x,y_nc,'ks');
        hold on
        p3 = plot(x,y,'ks');
        set(p3, 'markerfacecolor', get(p3, 'color'));

        layer = pile_input(1).layers;  
        for lay = 2:length(layer(:,1))-1
            y_loc = layer(lay,1) ; 

            xline(y_loc,'Color',[0.5 0.5 0.5]);
        end 
        set(gca, 'YAxisLocation', 'right')
        xlabel('$z [m]$','Interpreter','latex'); 
        ylabel('$\sigma_p D$   $[kN/m]$','Interpreter','latex'); 
        xlim([min(x),max(x)])
        ylim([0,max(y_nc)])
        camroll(270)
        hold off

        legend([p1 ,p2 ,p3],{'Brinch Hansen correction q(z)','Brinch Hansen no correction','Brinch Hansen correction'},'Interpreter','latex');
        title(['Plastic limit py springs for pile ' , num2str(pile)],'Interpreter','latex');
     
    end
end 
end