%% %SHEETPILE IS ALWAYS ON x = 0 
function [load_vector, phi_average_wall ,phi_average_sheetpile,Segment_friction] = Flamant(pile_input,quay_input,onoff_flamant)

lagen = quay_input.lagenbehind;  
floor = pile_input(1).levels.floorlevel; %maakt niet uit welke paal dit is, vloer is recht
height_block= quay_input.height_block;
dz = quay_input.dz ;
surface = quay_input.surface;
tip_sheet_pile= quay_input.tip_sheet_pile;
top_load= quay_input.top_load;
width_top_load= quay_input.width_top_load;
difference_deck_end_and_sheetpile= quay_input.difference_deck_end_and_sheetpile;
Length_deck= quay_input.Length_deck;
width_block= quay_input.width_block;
afstand_tot_tip_deck_and_top_load= quay_input.afstand_tot_tip_deck_and_top_load;
wall_overhang = quay_input.overhang_block;
total_depth = tip_sheet_pile;%height_block + tip_sheet_pile;
width_top_load2= quay_input.width_top_load2;
top_load2 = quay_input.top_load2;
afstand_tot_tip_deck_and_top_load2 = quay_input.afstand_tot_tip_deck_and_top_load2;
%% effective load from surface to deck level (floor) %%%%%%%%%%%%%%%%%
zz = surface:dz:floor;
% zz = surface:dz:floor;

    %Define phi for each dz step 
    for layer = 1:length(lagen(:,1))
        for fourgrids = 1:length(zz)

            if  round(lagen(layer,1),1) <= round(zz(fourgrids),1) && round(zz(fourgrids),1) < round(lagen(layer+1,1),1)               
                
                above_deck_phi(fourgrids) = lagen(layer+1,2);
                above_deck_weight(fourgrids) = lagen(layer+1,3);
                
            end    
        end 
    end 
   
%effective stress per depth for top part
    effective_stress = 0 ;
    effective_stress_above_floor = zeros(length(above_deck_weight),1);
    for i = 1:length(above_deck_weight)
        effective_stress = dz*above_deck_weight(i) + effective_stress ;
        effective_stress_above_floor(i) = effective_stress;
    end

% effective stress from floor to tip sheet %%%%%%%%%%%%%%%%%%%%
zz = floor:dz:total_depth;

    %Define phi for each dz step 
    for layer = 1:length(lagen(:,1))
        for fourgrids = 1:length(zz)
%       
            if  lagen(layer,1) <= zz(fourgrids) && zz(fourgrids) < lagen(layer+1,1)                
                below_deck_phi(fourgrids) = lagen(layer+1,2);
                below_deck_weight(fourgrids) = lagen(layer+1,3);
            end    
        end 
    end 

% effective stress per depth for top part
    effective_stress_below = 0 ;
    effective_stress_below_floor = zeros(length(below_deck_weight),1);
    for i = 1:length(below_deck_weight)
        effective_stress_below = dz*below_deck_weight(i) + effective_stress_below ;
        effective_stress_below_floor(i) = effective_stress_below;
    end
%%

yeff = 1; 
dx = dz; 
a = width_top_load/2;
a2 = width_top_load2/2; 
b = 100;
b2 = 100; 
P = effective_stress_above_floor(end);
q = top_load; 
q2 = top_load2; 

front_deck = difference_deck_end_and_sheetpile - Length_deck; 
back_block = front_deck + width_block;
dif_ori = 2* back_block; 

%% define cross sections for integration
%crossection
xline1 = 0;
xline2 = 0 ;
zline1 = floor+dz+dz;
zline2 = total_depth ;

%crossection2
x2line1 = back_block;
x2line2 = back_block ;
z2line1 = surface ;
z2line2 = floor-dz ;

%crosssection3 
x3line1 = back_block;
x3line2 = back_block+Length_deck-width_block ;
z3line1 =  floor-dz;
z3line2 = floor-dz ;

%crosssection4 
x4line1 = front_deck + Length_deck;
x4line2 = front_deck + Length_deck;
z4line1 = surface;
z4line2 = floor-dz ;
%%
X_surface =  a + afstand_tot_tip_deck_and_top_load+difference_deck_end_and_sheetpile;
X_deck_tip = b+difference_deck_end_and_sheetpile; 
x_left = -12; 
x_right = -x_left; 
x = x_left:dz:x_right;
z = surface:dz:total_depth;

X_mirror_surface =a + difference_deck_end_and_sheetpile+ afstand_tot_tip_deck_and_top_load - dif_ori; 
grid_dif = round(height_block/dz); 
grid_dif_inv = round((total_depth-floor)/dz); 
[X,Z] = meshgrid(x,z);

%for top load sig_zz figure
teta_1 = atan((a+X-X_surface)./(Z-surface));
teta_2 = atan((X-X_surface-a)./(Z-surface));
sig_zz = q./pi.*((teta_1-teta_2) + sin(teta_1).*cos(teta_1)-sin(teta_2).*cos(teta_2));

%for top load sig_zz figure MIRROR
tetaM_1 = atan((a+X+ X_mirror_surface)./(Z-surface));
tetaM_2 = atan((X+-a+ X_mirror_surface)./(Z-surface));
sig_zz_mirror = q./pi.*((tetaM_1-tetaM_2) + sin(tetaM_1).*cos(tetaM_1)-sin(tetaM_2).*cos(tetaM_2));

X_surface2 =  a2 + afstand_tot_tip_deck_and_top_load2+difference_deck_end_and_sheetpile;
X_mirror_surface2 =a2 + difference_deck_end_and_sheetpile+ afstand_tot_tip_deck_and_top_load2 - dif_ori; 
%2nd top load 

%for top load2 sig_zz figure
teta2_1 = atan((a2+X-X_surface2)./(Z-surface));
teta2_2 = atan((X-X_surface2-a2)./(Z-surface));
sig_zz2 = q2./pi.*((teta2_1-teta2_2) + sin(teta2_1).*cos(teta2_1)-sin(teta2_2).*cos(teta2_2));

%for top load2 sig_zz figure MIRROR
tetaM2_1 = atan((a2+X+ X_mirror_surface2)./(Z-surface));
tetaM2_2 = atan((X+-a2+ X_mirror_surface2)./(Z-surface));
sig_zz2_mirror = q2./pi.*((tetaM2_1-tetaM2_2) + sin(tetaM2_1).*cos(tetaM2_1)-sin(tetaM2_2).*cos(tetaM2_2));


%summation top loads 1 and 2 and mirror parts 1 and 2
sig_zz= sig_zz_mirror+ sig_zz+sig_zz2+sig_zz2_mirror; 
top_above_deck = zeros(size(X));
top_above_deck(1:grid_dif,:) = sig_zz(1:grid_dif,:) ;

%refractie part 
new_qloads = sig_zz(1+grid_dif,:);
horizontal_xgrid=( -x_left+difference_deck_end_and_sheetpile) /dx;
new_qloads(1:horizontal_xgrid+1) = 0;
discrete_x = X(1+grid_dif,:);

sink_hole_matrix = zeros(size(X));
for i = 1:length(new_qloads) 
teta = atan((X-discrete_x(i))./(Z-surface));
r = sqrt((X-discrete_x(i)).^2+(Z-surface).^2 );
sig_zz_half = 2.*new_qloads(i).*dx./(pi*r).*cos(teta).^3; 
sink_hole_matrix = sink_hole_matrix+ sig_zz_half;

end 

refractie_matrix = zeros(size(X));
refractie_matrix(grid_dif+1:end,:) = sink_hole_matrix(2:grid_dif_inv+2,:) ;
% refractie_matrix(grid_dif+2,:) = new_qloads;

%soilpressure half way 
phi_1 = atan((b+X-X_deck_tip)./(Z-surface));
phi_2 = atan((X-X_deck_tip-b)./(Z-surface));
sig_zz_soil = P./pi.*((phi_1-phi_2) + sin(phi_1).*cos(phi_1)-sin(phi_2).*cos(phi_2));
% sig_zz_soil = 2*P./pi.*(arctan(a/Z)+a.*Z./(a^2+z^2) 

%soilpressure linear increase 
soilpr_deck = zeros(size(X)); 
soilpr_deck(2:grid_dif+1,:) = effective_stress_above_floor(1:end-1).*ones(length(effective_stress_above_floor)-1,length(X));

% soilpr_deck = Z*yeff;
soilpr_below_deck = zeros(size(X)); 
soilpr_below_deck(grid_dif+2:end,:) = effective_stress_below_floor(1:end-1).*ones(length(effective_stress_below_floor)-1,length(X));

%sum up_sig_zz 
sig_zz_rel = zeros(length(z),length(x)); 
sig_zz_rel(grid_dif+2:end,:) = sig_zz_soil(1:grid_dif_inv,:) ;

x_mir_top_q = 0;
sig_zz_rel_mirror = fliplr(sig_zz_rel); 
sig_zz_rel_mirror = [sig_zz_rel_mirror(:,x_mir_top_q+1:end), zeros(length(sig_zz_rel_mirror),x_mir_top_q)];

% effective_stress_below_floor
refractie_matrix_mirror = fliplr(refractie_matrix); 

% sig_zz_tot = sig_zz_rel;
sig_zz_tot =  soilpr_below_deck +soilpr_deck+top_above_deck+refractie_matrix+refractie_matrix_mirror+sig_zz_rel_mirror+sig_zz_rel;
sig_zz_tot(isnan(sig_zz_tot))=0;

%% Make contour plot 
if onoff_flamant == 1 
% figure('Renderer', 'painters', 'Position', [300 100 450 350]) 
figure

subplot(4,3,[1 2 4 5 7 8 10 11])
sgtitle('Flamant effective vertical soil stresses','Fontsize',14,'Interpreter','latex');
h  = pcolor(X,Z,sig_zz_tot);
shading interp
hold on 
axis equal 
xlabel('$y$ [m]','Interpreter','latex');
ylabel('$z$ with respect to -NAP [m]','Interpreter','latex');
xlim([front_deck-1.3 8])
ylim([-1 6.4])
colormap((jet))

v = [ 0:5:max(sig_zz_tot(end,:))];
v = [ 0.00 0.00  ];
hold on 

% colorbar
set(gca, 'YDir','reverse')
rectangle('Position',[x_left,surface,-x_left+front_deck,height_block],'FaceColor',[1. 1. 1],'LineStyle', 'none'	)
rectangle('Position',[x_left,floor,-x_left,total_depth-floor],'FaceColor',[1. 1. 1],'LineStyle', 'none'	)
% set(h, 'EdgeColor', 'none');
n_piles  = length(pile_input);
for i = 1:n_piles
x_location_pile = front_deck+wall_overhang+ pile_input(i).x_coordinate; 
rectangle('Position',[x_location_pile,floor,0.2,total_depth-floor],'FaceColor',[1 1 1])
end 

rectangle('Position',[-0.1,floor,0.1,total_depth-floor],'FaceColor',[.7 .7 .7])
rectangle('Position',[front_deck,floor-0.1,Length_deck,0.2],'FaceColor',[.7 .7 .7])
rectangle('Position',[front_deck,surface,width_block,height_block],'FaceColor',[.7 .7 .7])

% caxis([0 80])
colorbar
c = colorbar;
c.Label.String = ' $\sigma_{zz} [kN/m^2]$';
c.Label.Interpreter = 'latex';

plot([front_deck,front_deck+10],[surface,surface],'k')
caxis([0 70])
plot([xline1 xline2], [zline1 zline2],'-.g','linewidth',3)
plot([x2line1 x2line2], [z2line1 z2line2],'-.m','linewidth',3)
plot([x3line1 x3line2], [z3line1 z3line2],'-.y','linewidth',3)
plot([x4line1 x4line2], [z4line1 z4line2],'-.b','linewidth',3)
axis equal 
set(gcf,'position',[0,0,1400,700])

%grond plot 
top_piles = zeros(1,n_piles); 
x_coordinate_piles = zeros(1,n_piles); 
for i = 1:n_piles
    top_piles(i) = pile_input(i).top_pile; 
    x_coordinate_piles(i) = front_deck+wall_overhang+ pile_input(i).x_coordinate; 
end 
plot([-10 x_coordinate_piles],[3.5 top_piles] ,'-ks')
yline( pile_input(1).levels.waterlevel,'b')
end 

%% cross sectional plot at the cross sections 1-4
% first cross section
hold on

syms y
syms x

% Create x and y over the slicing plane
xq=linspace(xline1,xline2,100);
yq=linspace(zline1,zline2,100);

% Interpolate over the surface
zq=interp2(X,Z,sig_zz_tot,xq,yq);
dq=sqrt((xq-xline1).^2 + (yq-zline1).^2);
p1 = polyfit(dq,zq,3);
pf1 = vpa( poly2sym(p1,y),3);

if onoff_flamant == 1
    subplot(4,3,6)
    hold on 
    plot(dq-xline1,zq,'g','linewidth',2)
    xlabel('Depth below deck $z[m]$','Interpreter','latex');
    ylabel(' $\sigma_z [kN/m^2]$','Interpreter','latex');
    fplot(y,pf1,[min(dq) max(dq)],'--k')
    legend('show','Location','best')
end
%%
% second cross section
x2q=linspace(x2line1,x2line2,100);
y2q=linspace(z2line1,z2line2,100);

% Interpolate over the surface
zq2=interp2(X,Z,sig_zz_tot,x2q,y2q); 
dq2=sqrt((x2q-x2line1).^2 + (y2q-z2line1).^2);
p2 = polyfit(dq2,zq2,3);
pf2 = vpa( poly2sym(p2,y),3);


if  onoff_flamant == 1
    subplot(4,3,3)
    hold on 
    fplot(y,pf2,[z2line1-surface z2line2-surface],'--k')
    legend('show','Location','best')
    plot( dq2,   zq2 ,'m','linewidth',2)
    xlabel('Depth below surface $z[m]$','Interpreter','latex');
    ylabel(' $\sigma_z [kN/m^2]$','Interpreter','latex');
end 
%%
% third cross section

x3q=linspace(x3line1,x3line2,100);
y3q=linspace(z3line1,z3line2,100);

% Interpolate over the surface
zq3=interp2(X,Z,sig_zz_tot,x3q,y3q); 
dq3=sqrt((x3q-x3line1).^2 + (y3q-z3line1).^2)+width_block-wall_overhang;
p3 = polyfit(dq3,zq3,3);
pf3 = vpa( poly2sym(p3,x),3);

if  onoff_flamant == 1
subplot(4,3,9)
hold on 
plot(dq3,zq3,'y','linewidth',2)
xlabel('Distance from first pile $x[m]$','Interpreter','latex');
ylabel(' $\sigma_z [kN/m^2]$','Interpreter','latex');
fplot(x,pf3,[min(dq3) max(dq3)],'--k')
legend('show','Location','best')
end
%%
% fourth cross section
x4q=linspace(x4line1,x4line2,100);
y4q=linspace(z4line1,z4line2,100);
% Interpolate over the surface
zq4=interp2(X,Z,sig_zz_tot,x4q,y4q); 
dq4=sqrt((x4q-x4line1).^2 + (y4q-z4line1).^2);
p4 = polyfit(dq4,zq4,3);
pf4 = vpa( poly2sym(p4,y),3);

if onoff_flamant == 1 
    subplot(4,3,12)
    plot( dq4,   zq4 ,'b','linewidth',2)
    xlabel('Depth below surface $z[m]$','Interpreter','latex');
    ylabel(' $\sigma_{zz} [kN/m^2]$','Interpreter','latex');
    hold on 
    fplot(y,pf4,[z4line1-surface z4line2-surface],'--k')
    legend('show','Location','best')
end 
%%
load_vector = { pf2, pf1, pf3, pf4,dq3,zq3};
y = 'y';
x = 'x';
phi_average_wall      = mean(above_deck_phi);
phi_average_sheetpile = mean(below_deck_phi);
%% FRICTION OF THE SEGMENT BOUNDARIES!!!! 

x = X;
y = Z;
z = sig_zz_tot;

zz = surface:dz:total_depth;
    %Define phi for each dz step 
    for layer = 1:length(lagen(:,1))
        for fourgrids = 1:length(zz)

            if  round(lagen(layer,1),1) <= round(zz(fourgrids),1) && round(zz(fourgrids),1) < round(lagen(layer+1,1),1)               
                
                phi_in_depth(fourgrids) = lagen(layer+1,2);
                
                
            end    
        end 
    end 
phi_in_depth_flip = flip(phi_in_depth); 
right_y_wedge(1) = 0;
for i = 1:length(zz)-1
    dy_wedge = [dz*tand(45-phi_in_depth_flip(i)/2)];
    right_y_wedge(i+1) = dy_wedge + right_y_wedge(i); 
end
right_y_wedge = flip(right_y_wedge);
left_y_wedge= []; 
for i = 1:length(zz)
    if dz*i < floor
        left_y_wedge(i) = back_block; 
    else
        left_y_wedge(i) = 0;
    end    
end

for i = 1:length(x)
    for j = 1:height(x)        
        if x(j,i) > right_y_wedge(j) || x(j,i) < left_y_wedge(j)
            z(j,i) = 0; 
        end 
    end 
end 
figure 
hold on 
sgtitle('Integrated area for side friction','Fontsize',14,'Interpreter','latex');
contour(x,y,z)
set(gca, 'YDir','reverse')
axis equal 
xlabel('$y$ [m]','Interpreter','latex');
ylabel('$z$ with respect to -NAP [m]','Interpreter','latex');
colormap((jet))
colorbar
c = colorbar;
c.Label.String = ' $\sigma_{zz} [kN/m^2]$';
c.Label.Interpreter = 'latex';

% COMPUTE THE FRICTION FORCE ON THE SEGMENT!

segment_width = quay_input.segment_width;
Ka_s=quay_input.Ka_s;
segment_friction_coef  = quay_input.segment_friction_coef;
[m,n] = size(z);
area = 0;
for i = 1:m-1
      for j = 1:n-1
          v0 = [x(i,j)     y(i,j)     z(i,j)    ];
          v1 = [x(i,j+1)   y(i,j+1)   z(i,j+1)  ];
          v2 = [x(i+1,j)   y(i+1,j)   z(i+1,j)  ];
          v3 = [x(i+1,j+1) y(i+1,j+1) z(i+1,j+1)];
          a = v1 - v0;
          b = v2 - v0;
          c = v3 - v0;
          A = 1/2*(norm(cross(a, c)) + norm(cross(b, c)));
          area = area + A;
      end
end
% fprintf('\nTotal area is: %f\n\n', area);
Segment_friction = area*Ka_s*segment_friction_coef*2; %two walls  
Segment_friction = Segment_friction/segment_width; %width of the segment  
end 
