
%% everything is FORCE/m quay wall 
function [loads] = Forces_on_quay(pile_input,quay_input,load_vector, phi_average_wall ,phi_average_sheetpile,Segment_friction)

    bovenbelasting_kademuur = 0; 

    wall_height = quay_input.height_block; 
    wall_weight = quay_input.weight_block; 
    wall_width  = quay_input.width_block; 
    wall_width_top  = quay_input.width_block_top; 
    h1 = quay_input.h1;
    h2 = quay_input.h2;
    wall_overhang = quay_input.overhang_block;
    Length_sheet = quay_input.Length_sheet;
    factor_z_eff = quay_input.factor_Z_eff; 
    force_wall = load_vector{1};
    force_sheet = load_vector{2};
    force_on_top_deck =  load_vector{3};
    force_wall_inv_boundary = load_vector{4};
    phi_w = phi_average_wall;
    phi_s = phi_average_sheetpile;
    
    wall_slope = asind((h1+h2)/sqrt((h1+h2)^2 + (wall_width-wall_width_top)^2 )); 
    alpha_w = wall_slope;
    delta_w = phi_w*2/3; 
    alpha_s = 90;
    delta_s = phi_s*1/3; 
    alpha_w_in = 90; %invisible boundary 
    delta_w_in = phi_w*3/3; 


    %Coulomb's earth pressure coefficients
    Ka_wall = sind(alpha_w+phi_w)^2 / ( sind(alpha_w)^2*sind(alpha_w-delta_w)*(1+ sqrt( (sind(phi_w+delta_w)*sind(phi_w))/(sind(alpha_w-delta_w)*sind(alpha_w))))^2);
    Ka_sheet = sind(alpha_s+phi_s)^2 / ( sind(alpha_s)^2*sind(alpha_s-delta_s)*(1+ sqrt( (sind(phi_s+delta_s)*sind(phi_s))/(sind(alpha_s-delta_s)*sind(alpha_s))))^2);
    Ka_wall_in = sind(alpha_w_in+phi_w)^2 / ( sind(alpha_w_in)^2*sind(alpha_w_in-delta_w_in)*(1+ sqrt( (sind(phi_w+delta_w_in)*sind(phi_w))/(sind(alpha_w_in-delta_w_in)*sind(alpha_w_in))))^2);
    sig_y_wall =  force_wall;
    force_sheet = force_sheet*Ka_sheet;
    horz_force_sheet = force_sheet*cosd(delta_s);
    force_wall_in = force_wall_inv_boundary*Ka_wall_in;
    horz_force_wall_inv_boundary =  force_wall_in*cosd(delta_w_in);
    %Compute the moment of the wall

    syms y
    
    F_sig = int(sig_y_wall,y,0,wall_height); %indien de vloer niet lang is... moet dit bij V_deck opgeteld worden..
    M_sig = int((wall_height-y)*sig_y_wall,y,0,wall_height);
    a_MC = M_sig/F_sig;
    V1 = h1*wall_width_top  ;
    V2 = 0.5*h1*h1/tand(wall_slope);
    V3 = h2*wall_width_top; 
    V4 = h1/tand(wall_slope)*h2;
    V5 = ((wall_width-wall_width_top)-h1/tand(wall_slope))*0.5*h2;
    y_bw =(wall_weight-10);
    y_aw = wall_weight;
    G_wall = V1*y_aw+V2*y_aw+V3*y_bw+V4*y_bw+V5*y_bw; 
    
    M1 = 0.5*wall_width_top*V1*y_aw;
    M2 = (wall_width_top+ 1/3*h1/tand(wall_slope))*V2*y_aw ;
    M3 =  0.5*wall_width_top*V3*y_bw;
    M4 = (wall_width_top+ 0.5*h1/tand(wall_slope))*V4*y_bw;
    M5 = (wall_width_top+ h1/tand(wall_slope) + 1/3*((wall_width-wall_width_top)-h1/tand(wall_slope)) )*V5*y_bw;
    
    a_G =  (M1+M2+M3+M4+M5)/G_wall; 
    angleF_G = delta_w+ (90-wall_slope); 
    afstand_F_tot_R = wall_width - a_G - a_MC/tand(wall_slope); 
    a_w = a_MC- tand(angleF_G)*afstand_F_tot_R; 
    F_hor_new = F_sig*Ka_wall*cosd(angleF_G); 
    F_ver_new = F_sig*Ka_wall*sind(angleF_G); 
    moment_on_floor = F_hor_new*a_w;

    F_wall_hor_inv_boundary = int(horz_force_wall_inv_boundary,y,0,wall_height); 

%     moment_on_floor= 
    normal_force_floor =  G_wall+F_ver_new;
    stress_moment = moment_on_floor /(1/6*wall_width^2);
    stress_normal_force = normal_force_floor/wall_width ;
    stress_water = stress_moment + stress_normal_force+bovenbelasting_kademuur;
    stress_back = -stress_moment + stress_normal_force+bovenbelasting_kademuur;
    %function for force of quay wall; 
    coefficients = polyfit([-wall_overhang, wall_width-wall_overhang], double([stress_water, stress_back]), 1);
    a = coefficients(1);
    b = coefficients(2);

    syms x 
    f_wall = a*x+b;
    
    B_influence = tand(45-phi_average_wall/2)*wall_height; 
    sigma_max = F_ver_new/2/B_influence ; %volume driehoek%
    dxflamant = load_vector{5}(2)-load_vector{5}(1); 
    dsigdx = sigma_max/B_influence;  
    dxsigma =  dsigdx*dxflamant; 

    sigma_lin_decent = zeros(size(load_vector{6})); 
    for i = 1:length(sigma_lin_decent)
        sigma_lin_decent(i)= sigma_max-dxsigma*(i-1);
        if sigma_lin_decent(i) <0 
            sigma_lin_decent(i) = 0; 
        end 
    end 
    zq3  = load_vector{6}- sigma_lin_decent; 
    dq3 = load_vector{5}; 
    p3 = polyfit(dq3,zq3,3);
    pf3 = vpa( poly2sym(p3,x),3);

    force_on_top_deck =  pf3;

    %Compute the deck_force + qload_on piles 

    %Moment around sheet connection point due to sheetpile = Msheet
    Msheet = int(horz_force_sheet*y,y,0,Length_sheet); 
    Fsheet = int(horz_force_sheet,y,0,Length_sheet);
    length_q = factor_z_eff*Length_sheet;
    Z_arm_q = Length_sheet - 0.5*length_q;
    q_force = Msheet/Z_arm_q;
    q_dist_load = q_force / length_q;
    V_deck = Fsheet- q_force;

    V_deck = V_deck +F_wall_hor_inv_boundary; %INDIEN DECK TE KORT IS MOET FWALL ERBIJ ANDERS WEGLATEN
    %multiply all loads by the center to centre distance piles in the y
    %direction 
    
    ctc_piles = quay_input.ctc_piles;
    q_dist_load = q_dist_load* ctc_piles;
    V_deck = V_deck * ctc_piles;
    f_wall  = f_wall * ctc_piles;
    force_on_top_deck = force_on_top_deck * ctc_piles;
    V_deck = V_deck - Segment_friction; %take friction off

    loads.q_dist_load = q_dist_load;
    loads.V_deck = V_deck;
    loads.f_wall = f_wall;
    loads.force_on_top_deck = force_on_top_deck;    

end 

