function Pile_interaction_plot2D3D(pile_input,pile_output,PLT)
 
    n_piles = size(pile_input,2);
%% 2D + 3D plots 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% unwrap pile_output for plots %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
pile = PLT.pileOI2D  ;
dz = pile_output(pile).grid.dz; 
xp = pile_output(pile).poly.xp; 
yp = pile_output(pile).poly.yp ; 
Xpile = pile_output(pile).pilegrid.X; 
Ypile = pile_output(pile).pilegrid.Y;  
Zpile = pile_output(pile).pilegrid.Z; 
Total_poly_cell = pile_output(pile).total_poly.Total_poly_cell; 
Total_poly_multi_cell = pile_output(pile).poly.reduced;
Total_poly_multi_cell_origional = pile_output(pile).poly.Total_poly_multi_cell;
X = pile_output(pile).grid.X ; 
Y = pile_output(pile).grid.Y ; 
Z = pile_output(pile).grid.Z ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 2D figure 1st pile%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 

if PLT.TDwedgeplot == 1 
    figure 
%     plt = 10;
    for plt = 1:length(Total_poly_multi_cell)
        subplot(ceil(length(Total_poly_multi_cell)^0.5),ceil(length(Total_poly_multi_cell)^0.5),plt)
                
        plot(Total_poly_multi_cell_origional(plt,:),'FaceColor', 'w')
        hold on
%         plot(Total_poly_multi_cell(plt,:),'FaceColor', 'b')
        
        
        axis equal
        hold on 
        plot(Total_poly_cell(plt),'FaceColor', 'w')
        sgtitle({'Pile wedges according to Brinch Hansen for each depth',['Hightlight pile ',num2str(pile)]},'Interpreter','latex');  
        title(['Depth =', num2str(plt*dz-dz),'m'],'Interpreter','latex'); 
        xlabel('$x[m]$','Interpreter','latex'); ylabel('$y [m]$','Interpreter','latex');
        xlim([min(min(min(xp))) max(max(max(xp)))+1])
        ylim([min(min(min(yp))) max(max(max(yp)))])
    end
end 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 3D figure all piles%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if PLT.D3wedgeplot == 1 
figure 
% movegui('northwest');
for plotten = 1:1 %n_piles
    surf(pile_output(plotten).grid.X, pile_output(plotten).grid.Y, pile_output(plotten).grid.Z, 'Facealpha', 0.9,'Edgealpha', 0.5,'FaceColor','w'); 
    hold on 
    surf(pile_output(plotten).pilegrid.X,pile_output(plotten).pilegrid.Y,pile_output(plotten).pilegrid.Z,'Facealpha', 0.4,'Edgealpha', 0.4,'FaceColor', 'k'); 
    
    %side piles 
%     negativeY
    surf(pile_output(plotten).grid.X, pile_output(plotten).grid.Y - pile_input(plotten).center2center_y, pile_output(plotten).grid.Z, 'Facealpha', 0.4,'Edgealpha', 0.5); 
    hold on 
    surf(pile_output(plotten).pilegrid.X,pile_output(plotten).pilegrid.Y-pile_input(plotten).center2center_y,pile_output(plotten).pilegrid.Z,'Facealpha', 0.4,'Edgealpha', 0.4,'FaceColor', 'k'); 
    
    %positiveY
    surf(pile_output(plotten).grid.X, pile_output(plotten).grid.Y + pile_input(plotten).center2center_y, pile_output(plotten).grid.Z, 'Facealpha', 0.4,'Edgealpha', 0.5); 
    hold on 
    surf(pile_output(plotten).pilegrid.X,pile_output(plotten).pilegrid.Y+pile_input(plotten).center2center_y,pile_output(plotten).pilegrid.Z,'Facealpha', 0.4,'Edgealpha', 0.4,'FaceColor', 'k'); 
    
end 
axis equal  
xlabel('$x [m]$','Interpreter','latex'); 
ylabel('$y [m]$','Interpreter','latex'); 
zlabel('$z [m]$','Interpreter','latex'); 
title('Pile wedges according to Brinch Hansen ','Interpreter','latex'); 
% xlim([-2,pile_input(end).x_coordinate+0.5])
% ylim([-3,3])
% zlim([ pile_input(1).top_pile-1, pile_input(end).top_pile+ pile_input(3).plastic_zone])
set(gca, 'CameraPosition', [-2000 -3000 -1000]);
set(gca, 'ZDir','reverse')

%%% SLOPE PLOT
% hold on
% [VX,VY] = meshgrid( -2:0.5:0.5, -2:0.5:2 );
% VZ = pile_input(1).top_pile - (VX-pile_input(end).x_coordinate).*pile_input(1).helling;
% surf(VX,VY,VZ,'Facealpha', 0.5,'Edgealpha', 0.3,'FaceColor', 'w'); 
axis equal; view(3)
end 
end 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
