
top_pile = zeros(1,n_piles);
for i = 1:n_piles 
    top_pile(i) = pile_input(i).top_pile;
end 
%subplot configuration 
N_rows = 8; 
Deck_plot = [1:n_piles]; 
for i = 1:n_piles
   Pile_plot{i} = (i-1+ (n_piles+1):n_piles:n_piles*(N_rows-1)) + n_piles; 
end 
%% Deflection plot 
if WPLOT == 1

figure
set(gcf,'position',[0,0,600,700])
sgtitle('Deflections','Fontsize',14,'Interpreter','latex');
%kesp
subplot(N_rows,n_piles,Deck_plot)
hold on 

fplot(w_d{1}(1),[X(1) X(2)],'-k');
fplot(w_d{2}(1),[X(2) X(3)],'-k');
fplot(w_d{2}(2),[X(3) X(4)],'-k'); 
if n_piles > 2
for i = 3:n_piles
    fplot(w_d{i}(1),[X(i+1) X(i+2)],'-k');
    hold on 
end 
end 
for i = 1:n_piles
    xline(pile_input(i).x_coordinate,'--');
end 
yline(0,'--');
set(gca, 'YDir','reverse')
xlabel('$x$ [m]','Interpreter','latex'); 
ylabel('$w$ [m]','Interpreter','latex');
%Piles 
for j = 1:n_piles
    hold on 
    subplot(N_rows,n_piles,Pile_plot{j})  
    for i = 1:length(Y{j})-1
        fplot(w_p{j}(i),[Y{j}(i) Y{j}(i+1)],'-k');
        hold on 
    end
    xline(top_pile(j),'-','hello');
    yline(0,'--');
    xlabel('$z$ [m]','Interpreter','latex');
    ylabel('$w$ [m]','Interpreter','latex');
    set(gca, 'YDir','reverse')
    xlim([min(Y{j}),max(Y{j})])
    camroll(270)
end 
end 
%% Moment plot  
if MPLOT ==1  
figure
set(gcf,'position',[0,0,600,700])
sgtitle('Bending Moments','Fontsize',14,'Interpreter','latex');
%kesp
subplot(N_rows,n_piles,Deck_plot)
hold on 
fplot(M_d{1}(1),[X(1) X(2)],'-k');
fplot(M_d{2}(1),[X(2) X(3)],'-k');
fplot(M_d{2}(2),[X(3) X(4)],'-k'); 
if n_piles > 2
for i = 3:n_piles
    fplot(M_d{i}(1),[X(i+1) X(i+2)],'-k');
    hold on 
end 
end 
for i = 1:n_piles
    xline(pile_input(i).x_coordinate,'--');
end 
yline(0,'--');
set(gca, 'YDir','reverse')
xlabel('$x$ [m]','Interpreter','latex');
ylabel('$M$ [kNm]','Interpreter','latex');
%Piles 
for j = 1:n_piles
    hold on 
    subplot(N_rows,n_piles,Pile_plot{j})  
    for i = 1:length(Y{j})-1
        fplot(M_p{j}(i),[Y{j}(i) Y{j}(i+1)],'-k');
        hold on 
    end
    xline(top_pile(j),'-','hello');
    yline(0,'--');
    xlabel('$z$ [m]','Interpreter','latex');
    ylabel('$M$ [kNm]','Interpreter','latex');
    set(gca, 'YDir','reverse')
    xlim([min(Y{j}),max(Y{j})])
    camroll(270)
end 
end
%% Shear plot  
if VPLOT == 1 

figure
set(gcf,'position',[0,0,600,700])
sgtitle('Shear Force','Fontsize',14,'Interpreter','latex');
%kesp
subplot(N_rows,n_piles,Deck_plot)
hold on 
fplot(V_d{1}(1),[X(1) X(2)],'-k');
fplot(V_d{2}(1),[X(2) X(3)],'-k');
fplot(V_d{2}(2),[X(3) X(4)],'-k'); 
if n_piles > 2
for i = 3:n_piles
    fplot(V_d{i}(1),[X(i+1) X(i+2)],'-k');
    hold on 
end 
end 
for i = 1:n_piles
    xline(pile_input(i).x_coordinate,'--');
end 
yline(0,'--');
set(gca, 'YDir','reverse')
xlabel('$x$ [m]','Interpreter','latex');
ylabel('$V$ [kN]','Interpreter','latex');
%Piles 
for j = 1:n_piles
    hold on 
    subplot(N_rows,n_piles,Pile_plot{j})  
    for i = 1:length(Y{j})-1
        fplot(V_p{j}(i),[Y{j}(i) Y{j}(i+1)],'-k');
        hold on 
    end
    xline(top_pile(j),'-','hello');
    yline(0,'--');
    xlabel('$z$ [m]','Interpreter','latex');
    ylabel('$V$ [kN]','Interpreter','latex');
    set(gca, 'YDir','reverse')
    xlim([min(Y{j}),max(Y{j})])
    camroll(270)
end 
end 
%% phi plot  
if PHIPLOT == 1 

figure
set(gcf,'position',[0,0,600,700])
sgtitle('Rotation','Fontsize',14,'Interpreter','latex');
%kesp
subplot(N_rows,n_piles,Deck_plot)
hold on 
fplot(phi_d{1}(1),[X(1) X(2)],'-k');
fplot(phi_d{2}(1),[X(2) X(3)],'-k');
fplot(phi_d{2}(2),[X(3) X(4)],'-k'); 
if n_piles > 2
for i = 3:n_piles
    fplot(phi_d{i}(1),[X(i+1) X(i+2)],'-k');
    hold on 
end 
end 
for i = 1:n_piles
    xline(pile_input(i).x_coordinate,'--');
end 
yline(0,'--');
set(gca, 'YDir','reverse')
xlabel('$x$ [m]','Interpreter','latex');
ylabel('$\phi$ [rad]','Interpreter','latex');
%Piles 
for j = 1:n_piles
    hold on 
    subplot(N_rows,n_piles,Pile_plot{j})  
    for i = 1:length(Y{j})-1
        fplot(phi_p{j}(i),[Y{j}(i) Y{j}(i+1)],'-k');
        hold on 
    end
    xline(top_pile(j),'-','hello');
    yline(0,'--');
    xlabel('$z$ [m]','Interpreter','latex');
    ylabel('$\phi$ [rad]','Interpreter','latex');
    set(gca, 'YDir','reverse')
    xlim([min(Y{j}),max(Y{j})])
    camroll(270)
end 

end

%% Pressures in Soil 

if SIGMAPLOT ==1 
n_piles = length(iteration);
%subplot 
N_rows_S = 4; % 1e is kesp, 2-5 zijn palen. 
for i = 1:n_piles
   Pile_plot_S{i} =  i:n_piles:n_piles*N_rows_S; 
end 

figure 
set(gcf,'position',[0,0,600,700])
for pile = 1:n_piles
    subplot(N_rows_S,n_piles,Pile_plot_S{pile})
    elastic_pressure_0 = []; 
    if iteration(pile).out_stuck ==1 
        start = 2; 
    else 
        start = 1; 
    end 

    max_elastic = []; 
    min_elastic = []; 
    for j = 1:iteration(pile).number_of_layers
%         j+1-iteration(pile).out_stuck; 
        if iteration(pile).new_matrix(j+1-iteration(pile).out_stuck,2) == 0 
            elastic = fplot(subs(w_p{pile}(j)*iteration(pile).spring_0(j)),[iteration(pile).y_values(j),iteration(pile).y_values(j+1)],'k');
            if start ==2 
            no_soil =  fplot(subs(0*iteration(pile).spring_0(1)),[iteration(pile).y_values(1),iteration(pile).y_values(2)],'g');
            end
        else 
            plastic_stress = cell2mat(iteration(pile).plastic_load(j));
            plastic = fplot(plastic_stress,[iteration(pile).y_values(j),iteration(pile).y_values(j+1)],'r');
        end 
     hold on   
    end
    if start == 2
%        legend([elastic plastic  no_soil],{'Elastic soil', 'Mobilized soil', 'No soil'},'location','southeast')       
    else 
%         legend([ elastic plastic ] ,{'Elastic soil', 'Mobilized soil'},'location','southeast') 
    end
    
    title({'Pressure [kN/m]',''},'Interpreter','latex');
    xlabel(' $z[m]$','Interpreter','latex');
    grid on
    grid minor
    
    
    sgtitle('Soil stresses in front of piles','Fontsize',15,'Interpreter','latex');
    yline(0,'HandleVisibility','off','Color', [0.3 0.3 0.3]);
    xlim([min(Y{1}),max(Y{1})])
    camroll(270)
end

end
