load('Bend_stress_B1.mat')
load('w_B1.mat')
load('MaxMoment_B1.mat')

load('Bend_stress_B2.mat')
load('w_B2.mat')
load('MaxMoment_B2.mat')

load('Bend_stress_B3.mat')
load('w_B3.mat')
load('MaxMoment_B3.mat')


F = [0:3:50]; 

%Batchnummer 1 = 240 

figure
sgtitle('D = 240 mm','Interpreter','latex'); 
set(gcf,'position',[200,220,1200,350])
subplot(1,3,1) 
plot(F,w_B1,'-s')
xlabel('$F$ [kPa]','Interpreter','latex'); 
ylabel('$w$ [m]','Interpreter','latex');
grid on 

subplot(1,3,2)
plot(F,MaxMoment_B1,'-s')
xlabel('$F$ [kPa]','Interpreter','latex'); 
ylabel('$M$ [kNm]','Interpreter','latex');
legend('Paalrij1','Paalrij2','Paalrij3','Paalrij4','Location','NorthWest','Interpreter','latex');
grid on 

subplot(1,3,3)
plot(F,-Bend_stress_B1,'-s')
xlabel('$F$ [kPa]','Interpreter','latex'); 
ylabel('$\sigma$ [$N/mm^2$] ','Interpreter','latex');
yline(18.39,'k--')
yline(22,'k-.')
yline(25.6,'k.')
legend('Paalrij1','Paalrij2','Paalrij3','Paalrij4','$f_{yk}$ 5\%','$f_{yk}$ 50\%','$f_{yk}$ 95\%','Location','NorthWest','Interpreter','latex');
grid on 

%Batchnummer 2 = 260  	
figure
sgtitle('D = 260 mm','Interpreter','latex'); 
set(gcf,'position',[200,220,1200,350])
subplot(1,3,1) 
plot(F,w_B2,'-s')
xlabel('$F$ [kPa]','Interpreter','latex'); 
ylabel('$w$ [m]','Interpreter','latex');
grid on 

subplot(1,3,2)
plot(F,MaxMoment_B2,'-s')
xlabel('$F$ [kPa]','Interpreter','latex'); 
ylabel('$M$ [kNm]','Interpreter','latex');
legend('Paalrij1','Paalrij2','Paalrij3','Paalrij4','Location','NorthWest','Interpreter','latex');
grid on 

subplot(1,3,3)
plot(F,-Bend_stress_B2,'-s')
xlabel('$F$ [kPa]','Interpreter','latex'); 
ylabel('$\sigma$ [$N/mm^2$] ','Interpreter','latex');
yline(18.39,'k--')
yline(22,'k-.')
yline(25.6,'k.')
legend('Paalrij1','Paalrij2','Paalrij3','Paalrij4','$f_{yk}$ 5\%','$f_{yk}$ 50\%','$f_{yk}$ 95\%','Location','NorthWest','Interpreter','latex');
grid on 

%Batchnummer 3 = 280  	
figure
sgtitle('D = 280 mm','Interpreter','latex'); 
set(gcf,'position',[200,220,1200,350])
subplot(1,3,1) 
plot(F,w_B3,'-s')
xlabel('$F$ [kPa]','Interpreter','latex'); 
ylabel('$w$ [m]','Interpreter','latex');
grid on 

subplot(1,3,2)
plot(F,MaxMoment_B3,'-s')
xlabel('$F$ [kPa]','Interpreter','latex'); 
ylabel('$M$ [kNm]','Interpreter','latex');
legend('Paalrij1','Paalrij2','Paalrij3','Paalrij4','Location','NorthWest','Interpreter','latex');
grid on 

subplot(1,3,3)
plot(F,-Bend_stress_B3,'-s')
xlabel('$F$ [kPa]','Interpreter','latex'); 
ylabel('$\sigma$ [$N/mm^2$] ','Interpreter','latex');
yline(18.39,'k--')
yline(22,'k-.')
yline(25.6,'k.')
legend('Paalrij1','Paalrij2','Paalrij3','Paalrij4','$f_{yk}$ 5\%','$f_{yk}$ 50\%','$f_{yk}$ 95\%','Location','NorthWest','Interpreter','latex');
grid on 