
function [M_res] = ROT_FUNC(quay_input,P_pile,V_pile,phi_pile)
  
E = quay_input.rotation_spring_input.E  ;  %Emodulus pile/headstock  %N/mm^2 
f_ck_K = quay_input.rotation_spring_input.f_ck_K ;   %N/mm^2 axial strength headstock -|

f_bend_pin = quay_input.rotation_spring_input.f_bend_pin; %N/mm^2 bending strength pin
L_pin = quay_input.rotation_spring_input.L_pin  ;  %mm height pin (can be same as height kesp..)
wp = quay_input.rotation_spring_input.wp ;    %%mm width pin
f_ck_P = quay_input.rotation_spring_input.f_ck_P;    %N/mm^2 axial strenght of pin -|
B = quay_input.rotation_spring_input.Dk  ;    %mm pile diameter at the cap (do not use a soft shell but effective diameter)

P = P_pile* 10^3; 
V =V_pile* 10^3; 
phi = phi_pile;


h = L_pin;

    R = 0.5*B; % radius 
    dx = 1; %in mm
    x = 0:dx:B;  % in mm 
    
    Apin = wp*dx; %%mm^2 per dx; 
    % remove square from pinhole on surface of the pile cap
    start_pin = 0.5*(B-wp)/dx; %number dx grids from left
    end_pin = start_pin + wp/dx; %number dx grids from right
    Apin_array = zeros(length(x),1);
    Apin_array(1:start_pin) = 0; 
    Apin_array(end_pin:end) = 0; 
    Apin_array(start_pin+1:end_pin) = Apin; 
    
    width = sqrt(2.*x.*R-x.^2)*2; % in mm per dx 
    disc_surface = width.*dx - Apin_array'; % in mm^2 per dx 


    %% method, shift untill P = surface*qc 
    for i = 0:10000
    qc =  - phi*(flip(x))*E/h;
    qc = qc + 0.001*i^2;
    qc(qc>f_ck_K) = f_ck_K;
    qc(qc<0) = 0;
    F_res = sum(qc.*disc_surface); 
        if F_res > P

            for j = 1:1000 
                qc = - phi*(flip(x))*E/h;
                qc = qc + 0.001*j + 0.001*(i-1)^2;  
                qc(qc>f_ck_K) = f_ck_K;
                qc(qc<0) = 0;
                
                F_res = sum(qc.*disc_surface); 
                    if F_res > P 
                        break 
                    end
            end 
            break 
        end 
    end 
    
    %Metric centrum seen from left
    x_MC = sum((qc.*disc_surface.*x))/sum(qc.*disc_surface); % let op de cirkel vorm
    M_e = (x_MC-R)*F_res*10^-6;
    
  
    E_pin = E; 
    Lpin_grid = 0:dx:L_pin;
    delta_Lpin = -phi*Lpin_grid;    
 
    %deze shape erin duwen tot de goede waarde van V eruit komt 
    indrukking = 0:dx*0.1:100; 
    
    for i = 1:length(indrukking) 
        
        epsilon_pin = (delta_Lpin+indrukking(i))/wp; 
        sigma_pin = E_pin.*epsilon_pin; 
        sigma_pin(sigma_pin>f_ck_P) = f_ck_P;
        sigma_pin(sigma_pin<-f_ck_P) = -f_ck_P;
        F_res_pin = sum(sigma_pin.*wp); 
            if F_res_pin > V 
                for j = 1:1000 

                    epsilon_pin = (delta_Lpin+indrukking(i)+0.001*j)/wp; 
                    sigma_pin = E_pin.*epsilon_pin; 
                    sigma_pin(sigma_pin>f_ck_P) = f_ck_P;
                    sigma_pin(sigma_pin<-f_ck_P) = -f_ck_P;
                    F_res_pin = sum(sigma_pin.*wp); 
                    if F_res_pin > V
                        break 
                    end
                end
                break     
            end
    end
    %Metric centre of pin seen from cap level
    M_pin = -sum(sigma_pin.*wp.*dx.*Lpin_grid)*10^-6;
    
    W_pin = 1/6*wp^3; 
    sig_pin_con = M_pin*10^6/W_pin; 
    if sig_pin_con > f_bend_pin 
        M_pin = 0 ;  
    end 
    
    M_res = M_e+ M_pin;  
    ratio = M_pin/(M_pin+M_e); 

end