% 
% n_piles = length(pile_input);
% for pile = 1:n_piles    
%     [pile_output(pile)] = pilefact(pile_input(pile));
% end        

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Import Poly Cells %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% [pile_output] = volred(pile_output,pile_input); 


function [pile_output] = pile_interaction(pile_output,pile_input)
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%open the pile_input and pile_output structures%%%%%%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% pile_input
    n_piles = length(pile_input) ;
    center2center_y = pile_input.center2center_y;
    helling = pile_input.helling;  
    D = pile_input.D ;
    top_piles = [pile_input.top_pile];   
    plastic_zones=  [pile_input.plastic_zone]; 
    dz = pile_input.gridsize_dz ;
    x_coordinates = [pile_input.x_coordinate ];
    y_coordinates = pile_input.y_coordinate ;
    lagen = pile_input.layers ;
    length_belowplastic = zeros(1,n_piles-1);
% pile_output
    
%pile outputs need to be splitted in a grid one and a BH factor one 
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
 
    for pile = 1:n_piles-1 %first pile does not hide behind the other piles the second pile will untill the end 
        
        plastic_grids(pile) = round(plastic_zones(pile+1)/pile_output(pile+1).grid.dz,3);
        grid_diff(pile) = round((top_piles(pile)-top_piles(pile+1))/pile_output(pile).grid.dz,3);
        if floor(plastic_grids(pile))/ceil(plastic_grids(pile)) ~= 1
            disp('Choose your plastic zones as multiple of your grid size '); 
        end 
        
        plastic_grids(pile) = round(plastic_grids(pile),0);
        grid_diff(pile) = round(grid_diff(pile),0) ;
        
        effective_grid(pile) = plastic_grids(pile) - grid_diff(pile);
        

        
        if effective_grid(pile)> plastic_zones(pile)/pile_output(pile+1).grid.dz
            length_belowplastic(pile,1) = plastic_grids(pile)-grid_diff(pile)-plastic_zones(pile)/pile_output(pile+1).grid.dz;
            effective_grid(pile) = plastic_zones(pile)/pile_output(pile+1).grid.dz; 
%             disp(['Plastic zone of pile ',num2str(pile+1), ' reaches deeper than previous pile'])
        end  
        %effective_grid
        %create empty grids for the volume_overlap
        
        Volume_overlap(pile+1).vol_over = zeros(plastic_grids(pile),plastic_grids(pile));
%         size(Volume_overlap)
        
                    %top part of the side hiding (part above effective_grid) (if
            %there is a effective_grid) 
%             if effective_grid(pile) > 0 
                for up_pg = 1:(grid_diff(pile)+effective_grid(pile))    %grid_diff(pile) ORIGINAL 
                      
                    
%                     size( pile_output(pile+1).total_poly.sidepiles_boundedY(up_pg)) 
%                     pile_output(1).grid.dz*area(intersect(pile_output(pile+1).total_poly.sidepiles_boundedY(up_pg),pile_output(pile+1).poly.Cropped_multi(up_pg,:)))
                    Volume_overlap(pile+1).vol_over(up_pg,:) = pile_output(1).grid.dz*area(intersect(pile_output(pile+1).total_poly.sidepiles_boundedY(up_pg),pile_output(pile+1).poly.Cropped_multi(up_pg,:)));
                    reduced_poly(pile+1).red(up_pg,:)=  subtract(pile_output(pile+1).poly.Cropped_multi(up_pg,:),pile_output(pile+1).total_poly.sidepiles_boundedY(up_pg)); 
                end 
%             end 
        
        
        if grid_diff(pile) > plastic_grids(pile)
            disp(['No possible interaction for pile ',num2str(pile+1)])
            %alleen volume reductie door de helling, hoogteverschil is te
            %groot, dz bottom komt niet tot de top van de paal die ervoor
            %zit
        else
             
            for pg = 1:effective_grid(pile)
                %multi is 3 piles in formation around pile  in the middle
                %to include side effects. this is only over the effective
                %grid depth. Another array for under and over is made. 
                multi_pilespolyshape(pile).multi(pg) = union(pile_output(pile+1).total_poly.sidepiles_boundedY(grid_diff(pile)+pg),pile_output(pile).total_poly.Total_poly_cell(pg)); 
                Volume_overlap(pile+1).vol_over(pg+grid_diff(pile),:) = pile_output(1).grid.dz*area(intersect(multi_pilespolyshape(pile).multi(pg), pile_output(pile+1).poly.Cropped_multi(grid_diff(pile)+pg,:))); 
                reduced_poly(pile+1).red(pg+grid_diff(pile),:) = subtract(pile_output(pile+1).poly.Cropped_multi(grid_diff(pile)+pg,:),     multi_pilespolyshape(pile).multi(pg)); 

            end 
            
         
            %if there is a bottom part, the side hiding is taken into
            %account as well
            if plastic_grids(pile) > effective_grid(pile)+grid_diff(pile)
                aa = round(1+grid_diff(pile)+effective_grid(pile),0);
                bb = round(grid_diff(pile)+effective_grid(pile)+length_belowplastic(pile),0);
                 for down_pg = aa:bb
                    Volume_overlap(pile+1).vol_over(down_pg,:) = pile_output(1).grid.dz*area(intersect(pile_output(pile+1).total_poly.sidepiles_boundedY(down_pg),pile_output(pile+1).poly.Cropped_multi(down_pg,:)));
                    reduced_poly(pile+1).red(down_pg,:) = subtract( pile_output(pile+1).poly.Cropped_multi(down_pg,:) , pile_output(pile+1).total_poly.sidepiles_boundedY(down_pg) ); 
                 end     
            end 
            
        end
    end 
    %first pile hiding sidewards, this does not need to be in the if else
    %statement because it is the first pile 
    for pg = 1:length(pile_output(1).grid.z)-1
        Volume_overlap(1).vol_over(pg,:) = pile_output(1).grid.dz*area(intersect(pile_output(1).total_poly.sidepiles_boundedY(pg),pile_output(1).poly.Cropped_multi(pg,:)));
        reduced_poly(1).red(pg,:) = subtract(pile_output(1).poly.Cropped_multi(pg,:)  ,  pile_output(1).total_poly.sidepiles_boundedY(pg));  
    end 


    %put volumes in the pile_output structure 
    for pile = 1:n_piles             
        pile_output(pile).volumes.hiding =  Volume_overlap(pile).vol_over;
        pile_output(pile).volumes.nocorrection = pile_output(pile).grid.dz.*area(pile_output(pile).poly.Total_poly_multi_cell); 
        pile_output(pile).volumes.slope = pile_output(pile).volumes.nocorrection- pile_output(pile).grid.dz.*area(pile_output(pile).poly.Cropped_multi);       
        pile_output(pile).volumes.correction = pile_output(pile).volumes.nocorrection-  (pile_output(pile).volumes.hiding + pile_output(pile).volumes.slope);
        
        
        pile_output(pile).poly.reduced = reduced_poly(pile).red;            
        
        volume_correction = pile_output(pile).volumes.correction;
        volume_nocorrection = pile_output(pile).volumes.nocorrection;
        weight = pile_output(pile).discrete_soil_info.weight;
        effective_weight = pile_output(pile).discrete_soil_info.effective_weight;
        %no correction volumeweight
        weigth_vol_nocorrection = bsxfun(@times,volume_nocorrection,effective_weight);
        weigth_vol_per_depth_nocorrection =sum(weigth_vol_nocorrection,1);   
        %correction volumeweight 
        weigth_vol_correction = bsxfun(@times,volume_correction,effective_weight);
        weigth_vol_per_depth_correction =sum(weigth_vol_correction,1);
        
        pile_output(pile).BH_factors.weigthfactor(:,1) = flip(1-(weigth_vol_per_depth_nocorrection - weigth_vol_per_depth_correction)./weigth_vol_per_depth_nocorrection); 
        BH_smooth = smoothdata(pile_output(pile).BH_factors.weigthfactor(1:end),'gaussian',5);
        pile_output(pile).BH_factors.smoothweigthfactor(:,1) = BH_smooth ;
        
    end
    
    % correction for cohesion -> this correction is based on the surface
    % area between the slide planes.     

    for pile = 1:n_piles
        vol_no_correction = pile_output(pile).volumes.nocorrection; 
        vol_correction = pile_output(pile).volumes.correction ;
        xp = pile_output(pile).poly.xp;
        yp = pile_output(pile).poly.yp; 
        xloc_slideplane = xp(:,1,:);
        xloc_slideplane = xloc_slideplane(:,:); 
        xloc_slideplane(:,end+1) = NaN;
        
         xdiff_layered = zeros(length(pile_output(pile).grid.z)-1 ,length(pile_output(pile).grid.z)-1 );     
        
        for depth = 1:length(pile_output(pile).grid.z)-1 
            xloc_slideplane(depth,1+end-depth)= x_coordinates(pile);
            for side = 1:length(pile_output(pile).grid.z)-1  
                xdiff_layered(depth,side)=  xloc_slideplane(depth,side+1)-xloc_slideplane(depth,side) ;
            end 
        end
        
        xdiff_layered;
        xdiff_layered(isnan(xdiff_layered))=0; 
        ydiff_layered = pile_output(pile).grid.dz ; 
        diag_length = sqrt(xdiff_layered.^2+ydiff_layered.^2); 
%         length(pile_output(pile).grid.z)-1 
        xlength_layer(pile).xlength_layer(:,:) =  xp(:,2,:)- xp(:,1,:) ;

 
        
        surface_no_correction = vol_no_correction ./ pile_output(pile).grid.dz ./  xlength_layer(pile).xlength_layer .* diag_length  ; 
        surface_correction = vol_correction ./ pile_output(pile).grid.dz ./ xlength_layer(pile).xlength_layer .* diag_length;
        cohesion = pile_output(pile).discrete_soil_info.cohesion(:,1);
        %no correction surfacecohesion
        cohesion_surf_nocorrection = bsxfun(@times,surface_no_correction,cohesion) ;
        cohesion_surf_nocorrection(isnan(cohesion_surf_nocorrection))=0;
        cohesion_surf_per_depth_nocorrection =sum(cohesion_surf_nocorrection,1)   ;
        %correction surfacecohesion 
        cohesion_surf_correction = bsxfun(@times,surface_correction,cohesion) ;
     
        cohesion_surf_correction(isnan(cohesion_surf_correction))=0;
        cohesion_surf_per_depth_correction =sum(cohesion_surf_correction,1);
            
        
        pile_output(pile).BH_factors.cohesionfactor(:,1) = flip(1-(cohesion_surf_per_depth_nocorrection - cohesion_surf_per_depth_correction)./cohesion_surf_per_depth_nocorrection);
        pile_output(pile).BH_factors.cohesionfactor(isnan(pile_output(pile).BH_factors.cohesionfactor(:,1)))= 1.0;
        BH_smooth = smoothdata(pile_output(pile).BH_factors.cohesionfactor(1:end),'gaussian',5);
        pile_output(pile).BH_factors.smoothcohesionfactor(:,1) = BH_smooth ;
    end      

    
   
    
end 
