
function [steps] = stepfunc(pile_input)
%% Import parameters 
    n_piles = size(pile_input,2);
    n_layers = zeros(n_piles,1); 
    top_piles = zeros(n_piles,1); 
    floor_level = zeros(n_piles,1); 
    pile_length = zeros(n_piles,1); 
    plastic_zones = zeros(n_piles,1); 
    for i = 1:n_piles 
        n_layers(i) = size(pile_input(i).layers,1)-1;
        top_piles(i) = pile_input(i).top_pile;
        floor_level(i) = pile_input(i).levels.floorlevel;
        pile_depth(i) = pile_input(i).levels.pile_tip;
        pile_length(i) = pile_input(i).pile_length; 
        plastic_zones(i) = pile_input(i).plastic_zone  ;
    end 

     %% give each pile their own customized springs per layer


    for pile = 1:n_piles
        if pile_input(pile).layers(end,1)< max(pile_depth)
            fprintf(2,'ERROR, Pile is deeper than specified soil layers. ')
            return 
        end 
    end 

    layer_counter = ones(1,n_piles);
    start_layer = zeros(1,n_piles); 
    %spring_layers = 
    for pile = 1:n_piles
        for layer = 1:n_layers(pile)
            depth_layer = pile_input(pile).layers(1+layer,1);
            if  top_piles(pile)  < depth_layer && depth_layer < pile_depth(pile)
                layer_counter(pile) = layer_counter(pile) + 1;
            else 
            end 
        end
    end 
    for pile = 1:n_piles
        for layer = 1:n_layers(pile)
            depth_layer = pile_input(pile).layers(1+layer,1);
            if top_piles(pile) < depth_layer
                start_layer(pile) = layer;
                break
            end 
        end
    end 

    for pile = 1:n_piles
        pile_discrete = zeros(1,layer_counter(pile)+2);
        for lay = 1: layer_counter(pile)
            pile_discrete(1) = floor_level(pile);
            pile_discrete(2) = top_piles(pile);
            pile_discrete(lay+2) = pile_input(pile).layers(start_layer(pile)+lay,1);
            pile_discrete(end) = pile_depth(pile);
        end 
        
        if pile_input(pile).levels.floorlevel == pile_input(pile).top_pile
            steps(pile).discrete_steps = pile_discrete(2:end);
        else 
            steps(pile).discrete_steps = pile_discrete(2:end);
        end 
    
        
    end 
end 
    
