
%% Iteration function 
function [iteration] = stress_iteration(Brinch_Hansen,Menard,iteration,w_p,pile_input,Normal_force,Shear_force,Phi_pile,q_dist_load_array)
k_max = 2;

    n_piles = length(iteration); 
    for npile = 1:n_piles  % iteratie matrix per paal 
        iteration(npile).Normal_force = Normal_force(npile);
        %import values 
        spring = iteration(npile).spring;
        spring_0 = iteration(npile).spring_0;
        y_values = iteration(npile).y_values;
        n_l = iteration(npile).number_of_layers; 
        initial_interval = iteration(npile).initial_interval;
        initial_matrix = iteration(npile).initial_matrix; 
        w = w_p{npile}; 
        
        
        
        if iteration(npile).out_stuck == 1 %watch out for the double split 
            if  pile_input(npile).levels.mid_sheet < pile_input(npile).top_pile
                y_values = y_values(3:end);
                spring = spring(3:end); 
                spring_0 = spring_0(3:end);
                w = w_p{npile}(3:end); 
                n_l = n_l-2;  
            else 
                y_values = y_values(2:end);
                spring = spring(2:end); 
                spring_0 = spring_0(2:end);
                w = w_p{npile}(2:end); 
                n_l = n_l-1;     
            end 
        end

        ELAST = [];
        yy = [];           
        syms f(y)  
        dz = pile_input(npile).gridsize_dz;
        depth_all = y_values(1):dz: y_values(end);

        for j = 1:n_l      
            depth = depth_all(initial_interval(j,1)):dz:depth_all(initial_interval(j,2));
            f(y) = vpa(subs(w(j))) ;
            %store values HIER GAAT IETS MIS HOOR
            spanning = f(depth).*spring_0(j);
            spring_0(j); 
            ELAST = [ELAST,spanning] ;
            yy = [yy,depth] ; 
        end
        check = zeros(length(yy),1); 

        BH = Brinch_Hansen(npile).Force_correction(1:end-1,1);  
        for k = 1: length(yy)

            if BH(k)>= ELAST(k)
                check(k) = 0; 
            else 
                check(k) = 1;
            end 
        end    

        soillevels = (iteration(npile).initial_matrix(2:end,1)); 
        % Give "true" if the element in "a" is a member of "b".
        locationyy = ismembertol(yy, soillevels);
        % Extract the elements of a at those indexes.
        indexes = find(locationyy)-1 ;
        check_check = check([indexes]);
        initial_matrix(2:length(check_check)+1,2) = check_check;  

        depth = [];
        sort = [];
        for k = 1:length(yy)-1 
            if abs(check(k+1)-check(k)) == 1 
                depth = [depth , depth_all(k+1)]; %k+1
                sort =  [sort ,check(k)]  ;
            end 
        end

        matrix = zeros(length(sort),3);
        matrix(:,1) = depth; 
        matrix(:,2) = sort; 

        new_matrix = sortrows([matrix;initial_matrix],1);

        new_matrix = uniquetol(new_matrix,'ByRows',true);
        % new_matrix = uniquetol(new_matrix, 'rows');

        %indien er dubble rijen ontstaan
        [U,idx,idy] = unique(new_matrix(:,1),'first');
        cnt = histc(new_matrix(:,1),U);
        U(cnt>1);  % duplicate values
        location = ismember(idy,find(cnt>1));  % locations of duplicates

        delete = []; 
        for i = 1:size(new_matrix,1)
            if location(i) == 1 && new_matrix(i,2) == 0 
                delete = [delete,i] ; 
            end 
        end 
        new_matrix([delete],:) =[] ; 
        menard = zeros(size(Menard(npile).discrete_springs,1),3); 
        menard(:,1) = Menard(npile).discrete_springs;
        menard(:,2) = Menard(npile).discrete_steps(1:end-1); 
        menard(:,3) = Menard(npile).discrete_steps(2:end); 

        q_load = cell(1,size(new_matrix,1)-1); 
        for i = 1:length(q_load) 
            q_load{i} = @(y) 0; 
        end 
        
        
        for j = 1:size(new_matrix,1)
            if isnan(new_matrix(j,2))
                new_matrix(j,3) = NaN ;
            end 
            if new_matrix(j,2) == 0
                for jj = 1:size(menard,1) 
                    if new_matrix(j,1) > menard(jj,2) && new_matrix(j,1) <= menard(jj,3) 
                        new_matrix(j,3) = menard(jj,1); 
                    end 
                end 
            end     
        end 
 
        for j = 1:size(new_matrix,1)-1
            if new_matrix(j+1,2) == 1
                new_matrix(j+1,3) = k_max; %deze waarde zou nog wel eens problemen kunnen geven 
                for jj = 1:size(menard,1) 
                    if new_matrix(j+1,1) > menard(jj,2) && new_matrix(j+1,1) <= menard(jj,3) 
                    
                         q_load{j}= matlabFunction(Brinch_Hansen(npile).functions(jj));
                    end 
                end 
            end 
        end
        
        
        %create a spring_0 
        spring_0 = zeros(size(new_matrix,1)-1,1);


        for j = 2:size(new_matrix,1)  
            for jj = 1:size(menard,1) 
                if new_matrix(j,1) > menard(jj,2) && new_matrix(j,1) <= menard(jj,3) 
                    spring_0(j-1,1) = menard(jj,1) ;
                end 
            end 
        end
        y_values = [];
        spring = new_matrix(2:end,3);
        y_values = new_matrix(1:end,1)' ;
        n_l = length(y_values)-1;
        initial_interval = [];
        initial_interval = zeros(n_l,2); 
        % locationinterval = ismember(yy,  new_matrix(1:end,1)');
        initial_interval(:,1) = round((y_values(1:end-1)./dz+1 )') ;  %deze formule gaat mis als y_value negatief wordt! even naar kijken na de lunch 
        % Extract the elements of a at those indexes.
        % indexes = find(locationyy); 

        initial_interval(1:end-1,2) =initial_interval(2:end,1)-1; 

        start_interval = initial_interval(1,1); 
        initial_interval = initial_interval - start_interval+1;
        initial_interval(end,2) = length(yy); 

        %insert everything in a structure for next itterations
        iteration(npile).yy = yy;
        iteration(npile).plastic_load = q_load; 
        iteration(npile).spring   = spring;
        iteration(npile).spring_0   = spring_0 ;
        iteration(npile).initial_matrix = initial_matrix; 
        iteration(npile).initial_interval = initial_interval;
        iteration(npile).number_of_layers = n_l;
        iteration(npile).y_values = y_values;
        iteration(npile).new_matrix = new_matrix;
        %in case of an out_stuck the "free part" of the pile needs to be put in the
        %input arrays as well. 
        iteration(npile).sheet_force = [];
       
       
        for i = 1:iteration(npile).number_of_layers 
            if (pile_input(npile).levels.tip_sheet > iteration(npile).y_values(i)) && ( pile_input(npile).levels.mid_sheet <=iteration(npile).y_values(i))
                iteration(npile).sheet_force(i) = q_dist_load_array(npile); 
            else 
                iteration(npile).sheet_force(i) = 0; 
            end
        end
      
               

        
        if iteration(npile).out_stuck == 1 
            
            if  pile_input(npile).levels.mid_sheet < pile_input(npile).top_pile
                iteration(npile).spring  = [k_max k_max iteration(npile).spring'];
                iteration(npile).spring_0  = [k_max k_max iteration(npile).spring_0']; 
                iteration(npile).y_values = [pile_input(npile).levels.floorlevel, pile_input(npile).levels.mid_sheet, y_values]; 
                iteration(npile).number_of_layers =  iteration(npile).number_of_layers + 2;  
                iteration(npile).plastic_load =  [{@(y) 0},{@(y) 0}, iteration(npile).plastic_load] ;
                iteration(npile).sheet_force = [ 0 q_dist_load_array(npile)  iteration(npile).sheet_force ]; 
                iteration(npile).sheet_force;
            
            
            else 

                iteration(npile).spring  = [k_max iteration(npile).spring'];
                iteration(npile).spring_0  = [k_max iteration(npile).spring_0']; 
                iteration(npile).y_values = [pile_input(npile).levels.floorlevel, y_values]; 
                iteration(npile).number_of_layers =  iteration(npile).number_of_layers + 1;  
                iteration(npile).plastic_load =  [{@(y) 0}, iteration(npile).plastic_load] ;
                iteration(npile).sheet_force = [ 0  iteration(npile).sheet_force ]; 
            end 
            
            
        end 
        
      
        iteration(npile).plastic_load; 
        iteration(npile).Normal_force = Normal_force(npile);
        iteration(npile).shear_force_pilehead = Shear_force(npile);
        iteration(npile).rotation_pilehead = Phi_pile(npile);
    end 
    iteration(npile).sheet_force;
    
   
    
    
end 